/**
 ******************************************************************************
 * @copyright Copyright (c) 2020 StarFive Technology Co.,Ltd.
 * 
 * @file ec.h
 * @author StarFive FW Team
 * @brief 
 ******************************************************************************
 */
#ifndef __TOOLS_EC_H__
#define __TOOLS_EC_H__

#include <stdio.h>
#include <stdint.h>

//
// ECDSA256 APIs
//
int ecdsa256_sign_ex(
        void *key, //key loaded by ec256_load_key()
        const void *kinv_bin,
        const void *rp_bin,
        const uint8_t *hash,
        int hash_len,
        uint8_t *sig,
        int sig_len
    );

int ecdsa256_sign(
        void *key, //key loaded by ec256_load_key()
        const uint8_t *hash,
        int hash_len,
        uint8_t *sig,
        int sig_len
    );

int ecdsa256_verify(
        void *key, //key loaded by ec256_load_key()
        const uint8_t *hash,
        int hash_len,
        uint8_t *sig,
        int sig_len
    );

//
// EC common APIs
//
void *ec_loadkey(
        const char *path //key file generated by: openssl
    );

int ec_pubkey2bin(
        void *key,
        uint8_t *bin,
        int bin_len
    );

#endif /* __TOOLS_EC_H__ */
