LIC_FILES_CHKSUM="\
    file://COPYING;md5=59530bdf33659b29e73d4adb9f9f6552\
    file://COPYING.LIB;md5=9f604d8a4f8e74f4f5140845a21b6674\
    file://COPYING3;md5=d32239bcb673463ab874e80d47fae504\
    file://COPYING3.LIB;md5=6a6a8e020838b23406c81b19c1d46df6\
    file://gas/COPYING;md5=d32239bcb673463ab874e80d47fae504\
    file://include/COPYING;md5=59530bdf33659b29e73d4adb9f9f6552\
    file://include/COPYING3;md5=d32239bcb673463ab874e80d47fae504\
    file://libiberty/COPYING.LIB;md5=a916467b91076e631dd8edb7424769c7\
    file://bfd/COPYING;md5=d32239bcb673463ab874e80d47fae504\
    "

# When upgrading to 2.39, please make sure there is no trailing .0, so
# that upstream version check can work correctly.
PV = "2.39"
CVE_VERSION = "2.39"
SRCBRANCH ?= "binutils-2_39-branch"

UPSTREAM_CHECK_GITTAGREGEX = "binutils-(?P<pver>\d+_(\d_?)*)"

SRCREV ?= "f89058434f13382c85b8729464192bc7763d88a4"
BINUTILS_GIT_URI ?= "git://sourceware.org/git/binutils-gdb.git;branch=${SRCBRANCH};protocol=git"
SRC_URI = "\
     ${BINUTILS_GIT_URI} \
     file://0004-Point-scripts-location-to-libdir.patch \
     file://0005-don-t-let-the-distro-compiler-point-to-the-wrong-ins.patch \
     file://0006-warn-for-uses-of-system-directories-when-cross-linki.patch \
     file://0007-fix-the-incorrect-assembling-for-ppc-wait-mnemonic.patch \
     file://0008-Use-libtool-2.4.patch \
     file://0009-Fix-rpath-in-libtool-when-sysroot-is-enabled.patch \
     file://0010-sync-with-OE-libtool-changes.patch \
     file://0011-Check-for-clang-before-checking-gcc-version.patch \
     file://0012-Only-generate-an-RPATH-entry-if-LD_RUN_PATH-is-not-e.patch \
     file://0013-CVE-2022-38533.patch \
     file://0014-CVE-2022-38128-1.patch \
     file://0014-CVE-2022-38128-2.patch \
     file://0014-CVE-2022-38128-3.patch \
     file://0001-Automatic-date-update-in-version.in.patch \
     file://0002-Automatic-date-update-in-version.in.patch \
     file://0003-Automatic-date-update-in-version.in.patch \
     file://0004-Automatic-date-update-in-version.in.patch \
     file://0005-Automatic-date-update-in-version.in.patch \
     file://0006-Automatic-date-update-in-version.in.patch \
     file://0007-Automatic-date-update-in-version.in.patch \
     file://0008-Automatic-date-update-in-version.in.patch \
     file://0009-Automatic-date-update-in-version.in.patch \
     file://0010-Automatic-date-update-in-version.in.patch \
     file://0011-Automatic-date-update-in-version.in.patch \
     file://0012-Automatic-date-update-in-version.in.patch \
     file://0013-Automatic-date-update-in-version.in.patch \
     file://0014-Automatic-date-update-in-version.in.patch \
     file://0015-Automatic-date-update-in-version.in.patch \
     file://0016-Automatic-date-update-in-version.in.patch \
     file://0017-Automatic-date-update-in-version.in.patch \
     file://0018-add-customer-pref-support.patch \
     file://0019-add-four-instruction-for-custom-CSRs.patch \
     file://0020-fix-a-merge-typo.patch \
"
S  = "${WORKDIR}/git"
# Already in 2.39 branch
# - https://sourceware.org/bugzilla/show_bug.cgi?id=29289
# - https://sourceware.org/bugzilla/show_bug.cgi?id=29290
CVE_CHECK_IGNORE += "CVE-2022-38126 CVE-2022-38127"
